#pragma once
#ifndef __RTOS_H
#define __RTOS_H

/******************************************************************************************
 *        ChipEnable.ru                                 *
 * http://chipenable.ru/index.php/programming-avr/item/110-planirovschik.html             *
 *                                                                                        *
 *    aka KontAr                                                  *
 * : 26.03.2014                                                                       *
 *                                                                                        *
 * :                                                                             *
 * -                                                        *
 * -                                                        *
 * -                                   *
 * -    ""                                                  *
 * -      ""                                       *
 *                                                                                        *
 * 18.05.2015, Shilov V.N. <shilow@ukr.net>                                               *
 * -   timing_delay  ST                                                        *
 * -                                  *
 *                                                                                        *
 ******************************************************************************************/

#include "stm8s.h"

//  
#define MAX_TASKS	9

#define  ENABLE_INTERRUPT enableInterrupts()
#define DISABLE_INTERRUPT disableInterrupts()

/**
 *  
 */
typedef struct task
{
   void (*pFunc) (void); //   
   uint16_t delay;       //     
   uint16_t period;      //   
   uint8_t run;          //     
} task;

/**
 * 
 */

/**
 *  
 */
void RTOS_Init (void);
void RTOS_SetTask (void (*taskFunc)(void), uint16_t taskDelay, uint16_t taskPeriod);
void RTOS_DeleteTask (void (*taskFunc)(void));
void RTOS_DispatchTask (void);

void Delay(__IO uint16_t nTime);

#endif /* __RTOS_H */
